﻿package com.selenetan.librarytest 
{
    import com.selenetan.core.STGlobal;
	import com.selenetan.core.STObject;
    import flash.display.Sprite;
	
	/**
     * ...
     * @author Selene
     */
    public class Ball extends STObject
    {
        private static var _instances:uint = 0;
        private var _id:uint;
        private var _density:Number;
        private var _originalRadius:Number;
        
        public function Ball($radius:Number, $color:uint = 0x000000) 
        {
            var s:Sprite = new Sprite();
            s.graphics.beginFill($color);
            s.graphics.drawCircle(0, 0, $radius);
            
            super(s, s);
            elasticity = 1.05;
            hitRadius = $radius;
            _originalRadius = $radius;
            velocity.x = Math.random() * 100 - 50;
            velocity.y = Math.random() * 100 - 50;
            
            _density = this.mass / (Math.PI * hitRadius * hitRadius);
            
            _id = _instances;
            ++_instances;
        }
        
        public function setMass($mass:Number):void
        {
            this.mass = $mass;
            hitRadius = Math.sqrt(this.mass / (Math.PI * _density));
            sprite.width = 2 * hitRadius;
            sprite.height = 2 * hitRadius;
        }
        
        override public function update():void
        {
            //trace(this.toString() + ".update()");
            
            // Make them wrap around the edge of the world
            var wWidth:Number = STGlobal.currentWorld.worldWidth;
            while (x < 0) {
                x += wWidth;
            }
            while (x > wWidth) {
                x -= wWidth;
            }
            
            if (y < 100 || y > 500) {
                x = Math.random() * wWidth;
                y = Math.random() * 400 + 100;
                velocity.x = Math.random() * 100 - 50;
                velocity.y = Math.random() * 100 - 50;
            }
            
            super.update();
        }
        
        
        override public function reset($x:Number = 0, $y:Number = 0, $args:Object = null):void
        {
            velocity.x = Math.random() * 100 - 50;
            velocity.y = Math.random() * 100 - 50;
            super.reset(Math.random() * 800, Math.random() * 400 + 100);
        }
        
        public function toString():String {
            return "[Ball #" + _id + "]";
        }
        
        
    }

}