﻿package com.selenetan.librarytest 
{
    import com.selenetan.core.STGlobal;
    import com.selenetan.core.STGroup;
    import com.selenetan.core.STObject;
    import com.selenetan.core.STTicker;
    import com.selenetan.core.STTickerEvent;
    import com.selenetan.core.STUtil;
	import com.selenetan.core.STWorld;
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.geom.Rectangle;
    import flash.utils.getTimer;
	
	/**
     * ...
     * @author Selene
     */
    public class World extends STWorld
    {
        private var _balls:STGroup
        private var _ticker:STTicker;
        
        public var canvas:Bitmap;
        
        public function World($container:Sprite, $viewWidth:Number, $viewHeight:Number) 
        {
            super($container, $viewWidth, $viewHeight, STWorld.WRAPPING_BOTH);
            worldWidth = 1200;
            worldHeight = 900;
            
            bgColor = 0xFFFFEEFF;
            
            STGlobal.currentWorld = this;
            
            _balls = new STGroup();
            
            var numBalls:int = 100;
            var b:Ball;
            
            var simpleCase:Boolean = false;
            
            if (simpleCase) {
                b = new Ball(50, 0x009900);
                b.x = 1;
                b.y = 300;
                b.velocity.x = 200;
                b.velocity.y = 0;
                
                this.add(b);
                _balls.addMember(b);
                
                b = new Ball(50, 0x990000);
                b.x = 799;
                b.y = 300;
                b.velocity.x = -200;
                b.velocity.y = 0;
                this.add(b);
                _balls.addMember(b);
            }
            else {
                for (var i:int = 0; i < numBalls; ++i) {
                    b = new Ball(10, int(Math.random() * (1 << 31)));
                    b.x = Math.random() * $viewWidth;
                    b.y = Math.random() * $viewHeight;
                    //b.setMass(Math.random() * 3 + 1);
                    
                    this.add(b);
                    _balls.addMember(b);
                }
            }
            
            super.update();
            
            canvas = new Bitmap(new BitmapData($viewWidth, $viewHeight, true, 0xFF000099));
            //canvas.smoothing = true;
            _drawContainer = new Sprite();
            _drawContainer.addChild(this.container);
            
            _ticker = STGlobal.ticker;
            _ticker.addEventListener(STTickerEvent.TICK, gameLoop);
            _ticker.start();
        }
        
        private function gameLoop(e:STTickerEvent):void
        {
            //trace("elapsed: " + e.elapsed);
            this.update();
            this.render();
        }
        
        override public function update():void
        {
            super.update();
            STUtil.checkResolveCollisions(_balls.members, _balls.members);
        }
        
        override public function render():void
        {
            super.render();
            /*
            container.x = 0;
            container.y = 0;
            
            canvas.bitmapData.fillRect(canvas.bitmapData.rect, 0xFFEEEEFF);
            
            if (wrapping != WRAPPING_NONE) {
                
                var nearHorizontalEdge:Boolean = false;
                var nearVerticalEdge:Boolean = false;
                
                // Do we need to draw the sides wrapping?
                if (wrapping & WRAPPING_HORIZONTAL && (viewX < viewWidth || viewX > worldWidth - viewWidth)) {
                    nearHorizontalEdge = true;
                    container.x = -worldWidth;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.x = worldWidth;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.x = 0;
                }
                
                // Do we need to draw the top and bottom wrapping?
                if (wrapping & WRAPPING_VERTICAL && (viewY < viewHeight || viewY > worldHeight - viewHeight)) {
                    nearVerticalEdge = true;
                    container.y = -worldHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.y = worldHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.y = 0;
                }
                
                // Do we need to draw the corners wrapping?
                if (wrapping & WRAPPING_BOTH && nearHorizontalEdge && nearVerticalEdge) {
                    container.x = -worldWidth;
                    container.y = -worldHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.y = worldHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.x = worldWidth;
                    container.y = -worldHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                    container.y = worldHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                }
                
                container.x = 0;
                container.y = 0;
            }
            
            canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
            */
            
            /*
            for (var i:int = -1; i <= 1; ++i) {
                container.x = i * viewWidth;
                for (var j:int = -1; j <= 1; ++j) {
                    container.y = j * viewHeight;
                    canvas.bitmapData.draw(_drawContainer, null, null, null, null, true);
                }
            }
            
            */
        }
        
        private function onBallsCollide($ball1:STObject, $ball2:STObject):void
        {
            trace(Ball($ball1).toString() + " collided with " + Ball($ball2).toString());
        }
        
        
        public function reset(e:Event):void
        {
            for each (var ball:Object in _balls.members) {
                Ball(ball).reset();
            }
        }
    }

}